/* Problem URL: https://codeforces.com/problemset/problem/2018/C */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vvi graph(n);

        rep(i, n - 1) {
            int a, b;
            cin >> a >> b;
            a--, b--;

            graph[a].push_back(b);
            graph[b].push_back(a);
        }

        if (n > 1) {
            n = 1 << (32 - __builtin_clz(n));
        }

        vi seg(n * 2);

        function<void(int, int, int, int, int)> update = [&](int i, int l, int r, int tl, int tr) {
            if (l > tr || r < tl) {
                return;
            }

            if (l >= tl && r <= tr) {
                seg[i]++;
                return;
            }

            int mid = (l + r) / 2;
            update(i * 2, l, mid, tl, tr );
            update(i * 2 + 1, mid + 1, r, tl, tr);
        };

        auto get = [&](int i) {
            int ans = 0;
            for (i = (i + n); i > 0; i /= 2) {
                ans += seg[i];
            }

            return ans;
        };

        function<int(int, int, int)> dfs = [&](int i, int p, int d) {
            int ans = d;

            repv(j, graph[i]) {
                if (j == p) {
                    continue;
                }

                rmax(ans, dfs(j, i, d + 1));
            }

            update(1, 0, n - 1, 0, d - 1);
            update(1, 0, n - 1, ans + 1, n - 1);
            return ans;
        };

        dfs(0, 0, 0);

        int ans = INT32_MAX >> 1;

        rep(i, n) {
            rmin(ans, get(i));
        }

        cout << ans << '\n';
    }
}
